﻿using Styx.Plugins;
using Styx.WoWInternals;
using Styx.CommonBot;
using Styx.Common;
using System;
using System.IO;
using System.Collections.Generic;
//using System.Timers;
using System.Text.RegularExpressions;
using System.Collections;
using System.Diagnostics;
using System.Runtime.InteropServices;
using System.Threading;
using Styx.MemoryManagement;

using System.Net.Sockets;
using System.Threading.Tasks;
using System.Threading;
using System.Text;
using System.Timers;

namespace BuddyCon2
{

    public class BuddyCon2 : HBPlugin
    {
        Connection con;
        String wowpath;

        DateTime startTime;

        public static BuddyCon2 _instance;
        public static BuddyCon2 Instance { get { return _instance; } }
        private static System.Timers.Timer _timer;

        #region Plugin
        public override string Author { get { return "thalord"; } }

        public override string Name { get { return "BuddyCon2"; } }

        public override void Pulse()
        {
            if (!con.connected())
            {
                if (BuddyConSettings2.Instance.debug) Logging.Write(string.Format("[bC2]: Version {0} try connect", Version.ToString()));

                con.connect();
            }

        }

        public override System.Version Version
        {
            get { return new System.Version(2, 0, 3); }
        }

        public override void OnButtonPress() { new FormSettings().ShowDialog(); }

        public override bool WantButton { get { return true; } }

        public override string ButtonText { get { return "Settings"; } }

        [DllImport("user32.dll")]
        static extern uint GetWindowThreadProcessId(IntPtr hWnd, IntPtr ProcessId);
        #endregion

        private Dictionary<string, string> data;



        public BuddyCon2() 
        {
            BuddyCon2._instance = this;
            Logging.Write(string.Format("[bC2]: Version {0} initalized", Version.ToString()));

            con = new Connection();
            con.connect();
            Chat.Say += Chat_Say;
            Chat.Yell += Chat_Yell;
            Chat.Whisper += Chat_Whisper;
            Chat.Party += Chat_Party;
            Chat.PartyLeader += Chat_Party;
            Chat.Guild += Chat_Guild;
            Chat.Emote += Chat_Emote;
            Chat.Battleground += Chat_BG;
            Chat.BattlegroundLeader += Chat_BG;
            Chat.Raid += Chat_Raid;
            Chat.RaidLeader += Chat_Raid;
            Chat.Officer += Chat_Officer;

            Styx.CommonBot.BotEvents.Player.OnPlayerDied += onDead;
            Styx.CommonBot.BotEvents.Player.OnLevelUp += onLevel;
            Styx.CommonBot.BotEvents.Player.OnMobKilled += onMobkill;

            Styx.CommonBot.BotEvents.OnBotStopped += onStop;
            Styx.CommonBot.BotEvents.OnBotStarted += onStart;

            Lua.Events.AttachEvent("GUILDBANKFRAME_OPENED", GbankUpdate);
            Lua.Events.AttachEvent("GUILDBANK_UPDATE_MONEY", GbankUpdate);

            Lua.Events.AttachEvent("CHAT_MSG_BN_WHISPER", BNetWhisper);
            Lua.Events.AttachEvent("GMRESPONSE_RECEIVED", GMResponse);

            data = new Dictionary<string, string>();
            data.Add("version", Version.ToString());
            data.Add("name", "");
            data.Add("level", "");
            data.Add("xp", "");
            data.Add("xp_needed", "");
            data.Add("chat_message", "");
            data.Add("chat_type", "");
            data.Add("chat_from", "");
            data.Add("screen", "");
            data.Add("nodeh", "");
            data.Add("runningtime", "");
            data.Add("xph", "");
            data.Add("timeolevel", "");
            data.Add("kills", "");
            data.Add("killsh", "");
            data.Add("honor", "");
            data.Add("honorh", "");
            data.Add("death", "");
            data.Add("deathh", "");
            data.Add("bgwin", "");
            data.Add("bglost", "");
            data.Add("server", "");
            data.Add("gbankmoney", "");
            data.Add("status", "");

            // init start values
            data["level"] = Convert.ToInt32(Styx.StyxWoW.Me.Level).ToString();
            data["apikey"] = BuddyConSettings2.Instance.apikey;
            data["server"] = Styx.StyxWoW.Me.RealmName.ToString();


            data["name"] = Styx.StyxWoW.Me.Name.ToString();
            if (Convert.ToInt32(Styx.StyxWoW.Me.Experience) > 0 && Convert.ToInt32(Styx.StyxWoW.Me.Experience) <= Int32.MaxValue) data["xp"] = Convert.ToInt32(Styx.StyxWoW.Me.Experience).ToString();
            if (Convert.ToInt32(Styx.StyxWoW.Me.NextLevelExperience) > 0 && Convert.ToInt32(Styx.StyxWoW.Me.NextLevelExperience) >= Int32.MaxValue) data["xp_needed"] = Convert.ToInt32(Styx.StyxWoW.Me.NextLevelExperience).ToString();
            wowpath = Styx.StyxWoW.Memory.Process.MainModule.FileName.Substring(0, Styx.StyxWoW.Memory.Process.MainModule.FileName.Length - 8);

            // start timer

            _timer = new System.Timers.Timer(15000);
            _timer.Elapsed += new ElapsedEventHandler(updater);
            _timer.Enabled = true;

        }

        private void updater(object sender, ElapsedEventArgs e)
        {
            if (BuddyConSettings2.Instance.debug) Logging.Write(string.Format("[bc2]: start updater"));
            BuddyCon2._instance.con.sendJSON(BuddyCon2._instance.getData());
            if (BuddyConSettings2.Instance.debug) Logging.Write(string.Format("[bc2]: end updater"));
        }


        public override void Dispose()
        {
            if (BuddyConSettings2.Instance.pdebug) Logging.Write(string.Format("[bc2]: start dispose"));

            BuddyCon2._timer.Stop();
            BuddyCon2._timer.Dispose();

            Chat.Say -= Chat_Say;
            Chat.Yell -= Chat_Yell;
            Chat.Whisper -= Chat_Whisper;
            Chat.Party -= Chat_Party;
            Chat.PartyLeader -= Chat_Party;
            Chat.Guild -= Chat_Guild;
            Chat.Emote -= Chat_Emote;
            Chat.Battleground -= Chat_BG;
            Chat.BattlegroundLeader -= Chat_BG;
            Chat.Raid -= Chat_Raid;
            Chat.RaidLeader -= Chat_Raid;
            Chat.Officer -= Chat_Officer;

            Styx.CommonBot.BotEvents.Player.OnPlayerDied -= onDead;
            Styx.CommonBot.BotEvents.Player.OnLevelUp -= onLevel;
            Styx.CommonBot.BotEvents.Player.OnMobKilled -= onMobkill;

            //Lua.Events.DetachEvent("CHAT_MSG_LOOT", Loot);
            //Lua.Events.DetachEvent("CHAT_MSG_COMBAT_XP_GAIN", Xp);
            //Lua.Events.DetachEvent("SCREENSHOT_SUCCEEDED", uploadscreen);


            Lua.Events.DetachEvent("GUILDBANKFRAME_OPENED", GbankUpdate);
            Lua.Events.DetachEvent("GUILDBANK_UPDATE_MONEY", GbankUpdate);

            Lua.Events.DetachEvent("CHAT_MSG_BN_WHISPER", BNetWhisper);
            Lua.Events.DetachEvent("GMRESPONSE_RECEIVED", GMResponse);

            Styx.CommonBot.BotEvents.OnBotStopped -= onStop;
            Styx.CommonBot.BotEvents.OnBotStarted -= onStart;

            data = null;

            con.disconnect();

            Logging.Write("[bC2]: Dispose ");

            if (BuddyConSettings2.Instance.pdebug) Logging.Write(string.Format("[bc2]: end dispose"));
            base.Dispose();


        }
        private Dictionary<string, string> getData()
        {
            if (BuddyConSettings2.Instance.debug) Logging.Write(string.Format("[bc2]: start getData"));

            //if (Styx.StyxWoW.IsInGame || Styx.StyxWoW.IsInWorld)
            //{
                try
                {
                    if (BuddyConSettings2.Instance.debug) Logging.Write(string.Format("[bc2]: start try getData"));

                    // fill rest data
                    //using (Styx.StyxWoW.Memory.AcquireFrame())
                    //{
                        if (BuddyConSettings2.Instance.debug) Logging.Write(string.Format("[bc2]: startAcquireFrame"));

                        BuddyCon2._instance.data["level"] = Convert.ToInt32(Styx.StyxWoW.Me.Level).ToString();

                        if (BuddyConSettings2.Instance.pdebug) Logging.Write("[bc2]: get server: " + Styx.StyxWoW.Me.RealmName.ToString());
                        //data["runningtime"] = Bots.Gatherbuddy.GatherbuddyBot.runningTime.TotalSeconds.ToString();
                        BuddyCon2._instance.data["apikey"] = BuddyConSettings2.Instance.apikey;
                        //data["runningtime"] = (DateTime.Now - startTime).TotalSeconds.ToString();
                        BuddyCon2._instance.data["xp"] = Convert.ToUInt32(Styx.StyxWoW.Me.Experience).ToString();
                        BuddyCon2._instance.data["xp_needed"] = Convert.ToUInt32(Styx.StyxWoW.Me.NextLevelExperience).ToString();
                        BuddyCon2._instance.data["xph"] = Convert.ToUInt32(Styx.CommonBot.GameStats.XPPerHour).ToString();
                        BuddyCon2._instance.data["timetolevel"] = Convert.ToUInt32(Styx.CommonBot.GameStats.TimeToLevel.TotalSeconds).ToString();

                        BuddyCon2._instance.data["kills"] = Convert.ToUInt32(Styx.CommonBot.GameStats.MobsKilled).ToString();
                        BuddyCon2._instance.data["killsh"] = Convert.ToUInt32(Styx.CommonBot.GameStats.MobsPerHour).ToString();

                        BuddyCon2._instance.data["honor"] = Convert.ToUInt32(Styx.CommonBot.GameStats.HonorGained).ToString();
                        BuddyCon2._instance.data["honorh"] = Convert.ToUInt32(Styx.CommonBot.GameStats.HonorPerHour).ToString();
                        BuddyCon2._instance.data["bgwin"] = Convert.ToUInt32(Styx.CommonBot.GameStats.BGsWon).ToString();
                        BuddyCon2._instance.data["bglost"] = Convert.ToUInt32(Styx.CommonBot.GameStats.BGsLost).ToString();

                        BuddyCon2._instance.data["gold"] = Convert.ToUInt32(Styx.StyxWoW.Me.Copper).ToString();
                        BuddyCon2._instance.data["nodeh"] = JSON.JsonEncode(Bots.Gatherbuddy.GatherbuddyBot.NodeCollectionCount);

                        if (BuddyConSettings2.Instance.debug) Logging.Write("[bc2]: gbankmoney" + data["gbankmoney"]);

                        if (BuddyConSettings2.Instance.debug) Logging.Write(string.Format("[bc2]: startAcquireFrame end"));

                    //}
                }
                catch (Exception e)
                {
                    if (BuddyConSettings2.Instance.debug) Logging.Write(string.Format("[bc2]: getting error {0} stack: {1}", e.Message, e.StackTrace));
                }
           // }
                if (BuddyConSettings2.Instance.debug) Logging.Write(string.Format("[bc2]: end getData"));

            return BuddyCon2._instance.data;
        }

        #region Chat
        private void Chatter(string message, string author = "", string type = "")
        {
            Logging.Write(string.Format("[bc2]: Chat: From: {1}  Message: {0} Type: {2}", message, author, type));
            getData();
            data["chat_message"] = message;
            data["chat_type"] = type;
            data["chat_from"] = author;

            if (
                (BuddyConSettings2.Instance.notfSay && type == "CHAT_MSG_SAY") ||
                (BuddyConSettings2.Instance.notfGuild && type == "CHAT_MSG_GUILD") ||
                (BuddyConSettings2.Instance.notfBG && (type == "CHAT_MSG_BATTLEGROUND" || type == "CHAT_MSG_BATTLEGROUND_LEADER")) ||
                (BuddyConSettings2.Instance.notfRaid && (type == "CHAT_MSG_RAID" || type == "CHAT_MSG_RAID_LEADER")) ||
                (BuddyConSettings2.Instance.notfWhisper && type == "CHAT_MSG_WHISPER")
                )
            {
                if (BuddyConSettings2.Instance.debug) Logging.Write("[bc2]: send notification");
                Util.sendToProwl("Chat", string.Format("[bc2]: Chat: From: {1}  Message: {0} Type: {2}", message, author, type), data["name"], data["server"]);
                if (BuddyConSettings2.Instance.androidapi.Length > 10) Util.SendNotification(BuddyConSettings2.Instance.androidapi, "{\"from\":\"" + author + "\", \"message\":\"" + message + "\", \"type\":\"" + type + "\"}");
            }
            if (BuddyConSettings2.Instance.scChat) screenie();
            con.sendJSON(data);
            data["chat_message"] = "";
            data["chat_type"] = "";
            data["chat_from"] = "";
        }
        private void BNetWhisper(object sender, LuaEventArgs args)
        {
            if (BuddyConSettings2.Instance.debug) Logging.Write(string.Format("[bc2]: Chat: From: {1}  Message: {0} Type: {2}", (string)args.Args[0], args.Args[1], args.ToString()));
            Thread thread = new Thread(delegate() { Chatter((string)args.Args[0], (string)args.Args[1].ToString(), "BNet"); });
            thread.Start();
        }

        private void GMResponse(object sender, LuaEventArgs args)
        {
            if (BuddyConSettings2.Instance.debug) Logging.Write(string.Format("[bc2]: Chat: From: {1}  Message: {0} Type: {2}", (string)args.Args[0], args.Args[1], args.ToString()));
        }

        private void Chat_Officer(Chat.ChatLanguageSpecificEventArgs e)
        {
            Thread thread = new Thread(delegate() { Chatter(e.Message, e.Author, e.EventName); });
            thread.Start();
            //Chatter(e.Message, e.Author, e.EventName);

        }
        private void Chat_Raid(Styx.CommonBot.Chat.ChatLanguageSpecificEventArgs e)
        {
            Thread thread = new Thread(delegate() { Chatter(e.Message, e.Author, e.EventName); });
            thread.Start();
            //Chatter(e.Message, e.Author, e.EventName);
        }

        private void Chat_BG(Styx.CommonBot.Chat.ChatLanguageSpecificEventArgs e)
        {
            Thread thread = new Thread(delegate() { Chatter(e.Message, e.Author, e.EventName); });
            thread.Start();
            //Chatter(e.Message, e.Author, e.EventName);        
        }

        private void Chat_Emote(Styx.CommonBot.Chat.ChatAuthoredEventArgs e)
        {

            Thread thread = new Thread(delegate() { Chatter(e.Message, e.Author, e.EventName); });
            thread.Start();
            //Chatter(e.Message, e.Author, e.EventName);        
        }

        private void Chat_Party(Styx.CommonBot.Chat.ChatLanguageSpecificEventArgs e)
        {
            Thread thread = new Thread(delegate() { Chatter(e.Message, e.Author, e.EventName); });
            thread.Start();
            //Chatter(e.Message, e.Author, e.EventName);        
        }

        private void Chat_Whisper(Styx.CommonBot.Chat.ChatWhisperEventArgs e)
        {
            Thread thread = new Thread(delegate() { Chatter(e.Message, e.Author, e.EventName); });
            thread.Start();
            //Chatter(e.Message, e.Author, e.EventName);        
        }

        private void Chat_Yell(Styx.CommonBot.Chat.ChatLanguageSpecificEventArgs e)
        {
            Thread thread = new Thread(delegate() { Chatter(e.Message, e.Author, e.EventName); });
            thread.Start();
            //Chatter(e.Message, e.Author, e.EventName);        
        }

        private void Chat_Say(Styx.CommonBot.Chat.ChatLanguageSpecificEventArgs e)
        {
            Thread thread = new Thread(delegate() { Chatter(e.Message, e.Author, e.EventName); });
            thread.Start();
            //Chatter(e.Message, e.Author, e.EventName);        
        }

        private void Chat_Guild(Styx.CommonBot.Chat.ChatGuildEventArgs e)
        {
            Thread thread = new Thread(delegate() { Chatter(e.Message, e.Author, e.EventName); });
            thread.Start();
            //Chatter(e.Message, e.Author, e.EventName);        
        }
        #endregion


        internal void screenie()
        {
            Logging.Write("[bc2]: Screenshot requested");
            Lua.Events.AttachEvent("SCREENSHOT_SUCCEEDED", uploadscreen);
            Lua.DoString("TakeScreenshot()");
        }
        internal void sendChat(string type, string message, string to)
        {
            Lua.DoString("SendChatMessage(\"" + message + "\", \"" + type + "\", nil, \"" + to + "\");");
            Logging.Write(string.Format("[bc2]: send Chat channel: {0} Message: {1} To:{2}", type, message, to));

        }
        #region onX

        private void GbankUpdate(object sender, LuaEventArgs args)
        {
            BuddyCon2._instance.data["gbankmoney"] = Convert.ToUInt32(Styx.WoWInternals.Lua.GetReturnVal<Int32>("return GetGuildBankMoney()", 0)).ToString();
        }

        private void onMobkill(BotEvents.Player.MobKilledEventArgs args)
        {
            con.sendJSON(getData());
        }

        private void onStart(EventArgs args)
        {
            startTime = DateTime.Now;
            // if(times != null)
            //    times.Dispose(); 
            if (BuddyConSettings2.Instance.pdebug) Logging.Write(string.Format("[bc2]: start onStart"));

            //using (Styx.StyxWoW.Memory.AcquireFrame()){
            Styx.CommonBot.BotEvents.Player.OnPlayerDied += onDead;
            Styx.CommonBot.BotEvents.Player.OnLevelUp += onLevel;
            //Styx.CommonBot.BotEvents.Player.OnMobKilled += onMobkill;

            BuddyCon2._instance.data["name"] = Styx.StyxWoW.Me.Name.ToString();
            BuddyCon2._instance.data["server"] = Styx.StyxWoW.Me.RealmName.ToString();
            BuddyCon2._instance.data["gbankmoney"] = Convert.ToUInt32(Styx.WoWInternals.Lua.GetReturnVal<Int32>("return GetGuildBankMoney()", 0)).ToString();

            //}

            Logging.Write("[bc2]: Bot started");
            if (BuddyConSettings2.Instance.notfStart)
                Util.sendToProwl("Bot", "Bot started", BuddyCon2._instance.data["name"], BuddyCon2._instance.data["server"]);

            BuddyCon2._instance.data["status"] = "Bot started";
            con.sendJSON(BuddyCon2._instance.data);
            BuddyCon2._instance.data["status"] = "";

            if (BuddyConSettings2.Instance.pdebug) Logging.Write(string.Format("[bc2]: end onStart"));


        }

        private void onStop(EventArgs args)
        {
            //Thread thread = new Thread(delegate() { 

            if (BuddyConSettings2.Instance.pdebug) Logging.Write(string.Format("[bc2]: onstop start "));

            //times = new Timer(timesUpdater, data, 0, 15000);
            //using (Styx.StyxWoW.Memory.AcquireFrame()){
            Styx.CommonBot.BotEvents.Player.OnPlayerDied -= onDead;
            Styx.CommonBot.BotEvents.Player.OnLevelUp -= onLevel;
            //Styx.CommonBot.BotEvents.Player.OnMobKilled -= onMobkill;

            //Lua.Events.DetachEvent("SCREENSHOT_SUCCEEDED", uploadscreen);
            //}
            Logging.Write("[bc2]: Bot stopped");
            if (BuddyConSettings2.Instance.notfStop)
                Util.sendToProwl("Bot", "Bot stopped", BuddyCon2._instance.data["name"], BuddyCon2._instance.data["server"]);

            BuddyCon2._instance.data["status"] = "Bot stopped";
            con.sendJSON(BuddyCon2._instance.data);
            BuddyCon2._instance.data["status"] = "";
            if (BuddyConSettings2.Instance.pdebug) Logging.Write(string.Format("[bc2]: onstop end "));
            //});
            //thread.Start();

        }

        private void onDead()
        {
            using (Styx.StyxWoW.Memory.AcquireFrame())
            {
                BuddyCon2._instance.data["death"] = Convert.ToInt32(Styx.CommonBot.GameStats.Deaths).ToString();
                BuddyCon2._instance.data["deathh"] = Convert.ToInt32(Styx.CommonBot.GameStats.DeathsPerHour).ToString();
            }
            Logging.Write("[bc2]: Died!");
            if (BuddyConSettings2.Instance.notfDied)
                Util.sendToProwl("Died", "Died", data["name"], data["server"]);
            BuddyCon2._instance.data["status"] = "Died!";
            con.sendJSON(BuddyCon2._instance.data);
            BuddyCon2._instance.data["status"] = "";
            if (BuddyConSettings2.Instance.scDied) screenie();

        }

        private void onLevel(BotEvents.Player.LevelUpEventArgs args)
        {

            BuddyCon2._instance.data["level"] = Convert.ToInt32(Styx.StyxWoW.Me.Level).ToString();

            Logging.Write("[bc2]: Level up!");

            if (BuddyConSettings2.Instance.notfLevel)
                Util.sendToProwl("Level", "Level up", BuddyCon2._instance.data["name"], BuddyCon2._instance.data["server"]);

            BuddyCon2._instance.data["status"] = "Level up!";
            con.sendJSON(BuddyCon2._instance.data);
            BuddyCon2._instance.data["status"] = "";

            if (BuddyConSettings2.Instance.scLevel) screenie();
        }
        #endregion

        private void uploadscreen(object sender, LuaEventArgs args)
        {
            Lua.Events.DetachEvent("SCREENSHOT_SUCCEEDED", uploadscreen);
            var directory = new DirectoryInfo(wowpath + "\\Screenshots\\");
            string ret = "";
            if (BuddyConSettings2.Instance.scripturl.Length > 15)
                ret = Util.PostToFtp(directory + Util.GetLatestWritenFileFileInDirectory(directory).ToString());
            else
                ret = Util.PostToImgur(directory + Util.GetLatestWritenFileFileInDirectory(directory).ToString(), "e6b704a473bc5894e03ff99db649e825");

            BuddyCon2._instance.data["screen"] = ret;
            BuddyCon2._instance.data["status"] = "Screenshot sent";
            con.sendJSON(BuddyCon2._instance.data);
            BuddyCon2._instance.data["status"] = "";
            BuddyCon2._instance.data["screen"] = "";
            Logging.Write("[bc2]: Screenshot sent");

        }


    }
}
