﻿using Styx.Common;
using System;
using System.Net;
using System.Text;
using System.IO;
using System.Collections.Generic;
using System.Drawing.Imaging;
using System.Drawing;
using System.Runtime.InteropServices;
using Styx;
using System.Threading;
using System.Net.Sockets;
using System.Threading.Tasks;
using System.Collections;

namespace BuddyCon2
{
    public class Connection
    {
        TcpClient tcpClient;
        NetworkStream serverStream = default(NetworkStream);
        string readData = string.Empty;
        public bool connected()
        {
            if (tcpClient == null) return false;
            return tcpClient.Connected;
        }
        public void sendString(String js)
        {
            if (BuddyConSettings2.Instance.debug) Logging.Write(string.Format("[bC]: start send string"));
            Task taskOpenEndpoint = Task.Factory.StartNew(() =>
                {
                    Byte[] byteDateLine = Encoding.ASCII.GetBytes(js);
                    serverStream.Write(byteDateLine, 0, byteDateLine.Length);
                    serverStream.Flush();
                });
            if (BuddyConSettings2.Instance.debug) Logging.Write(string.Format("[bC]: end send string"));

        }
        public void sendJSON(Dictionary<string, string> js)
        {
            sendString(JSON.JsonEncode(js));
        }
        public Connection()
        {
        }
        public void disconnect()
        {
            serverStream.Close();
            tcpClient.Close();
        }
        public void connect()
        {

            try
            {
                tcpClient = new TcpClient();
                // Socket 
                tcpClient.Connect("buddycon.eu", 1337);

                serverStream = tcpClient.GetStream();
                String conString = "{\"apikey\":\"" + BuddyConSettings2.Instance.apikey + "\", \"name\":\"" + Styx.StyxWoW.Me.Name.ToString() + "\", \"server\":\"" + Styx.StyxWoW.Me.RealmName.ToString() + "\"}";
                byte[] outStream = Encoding.ASCII.GetBytes(conString);
                if (BuddyConSettings2.Instance.debug) Logging.Write(string.Format("[bC]: socket connect with {0}",conString));
                serverStream.Write(outStream, 0, outStream.Length);
                serverStream.Flush();

                // upload as javascript blob
                Task taskOpenEndpoint = Task.Factory.StartNew(() =>
                {
                    while (tcpClient.Connected)
                    {
                        // Read bytes
                        serverStream = tcpClient.GetStream();
                        byte[] message = new byte[4096];
                        int bytesRead;
                        bytesRead = 0;

                        try
                        {
                            // Read up to 4096 bytes
                            bytesRead = serverStream.Read(message, 0, 4096);
                        }
                        catch
                        {
                            /*a socket error has occured*/
                            if (BuddyConSettings2.Instance.debug) Logging.Write(string.Format("[bC]: socket error"));
                        }

                        //We have rad the message.
                        ASCIIEncoding encoder = new ASCIIEncoding();
                        // Update main window
                        AddMessage(encoder.GetString(message, 0, bytesRead));
                        Thread.Sleep(500);
                    }
                });
            }
            catch (Exception e)
            {
                if (BuddyConSettings2.Instance.debug) Logging.Write(string.Format("[bC]: socket error {0}", e.Message));

            }
        }

        private void AddMessage(string msg)
        {
            /*Dispatcher.BeginInvoke(DispatcherPriority.Input, (ThreadStart)(
             () =>
             {*/
            if (BuddyConSettings2.Instance.debug) Logging.Write(string.Format("[bC]: socket >> {0}", msg));
            if (msg == "") disconnect();
            else
            {
                Hashtable resJson = (Hashtable)JSON.JsonDecode(msg);

                switch ((string)resJson["action"])
                {
                    case "":
                        break;
                    case "killwow":
                        Logging.Write(string.Format("[bC]:  {0}", "Kill Wow requested!"));
                        Styx.StyxWoW.Memory.Process.Kill();
                        break;
                    case "screen":
                        BuddyCon2.Instance.screenie();
                        break;
                    case "chat":
                        BuddyCon2.Instance.sendChat((string)resJson["type"], (string)resJson["message"], (string)resJson["to"]);
                        break;
                    case "stophb":
                        Styx.CommonBot.TreeRoot.Stop();
                        break;
                    case "starthb":
                        Styx.CommonBot.TreeRoot.Start();
                        break;
                    default:
                        Logging.Write(string.Format("[bC2]:  {0}", msg));
                        break;

                }
            }
            // }));
        }
    }
}